| The Gaudi Framework v29r1 (5cd95fa2)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | List of all members
Gaudi::RootPerfMonSvc Class Reference

Description: More...

`#include <src/RootPerfMonSvc.h>`

Inheritance diagram for Gaudi::RootPerfMonSvc:
[legend]
Collaboration diagram for Gaudi::RootPerfMonSvc:
[legend]

## Public Member Functions
| ~RootPerfMonSvc () override=default
| Standard destructor. More...
StatusCode | error (const std::string &msg)
| Standard way to print errors. More...
StatusCode | initialize () override
| Service overload: initialize the service. More...
StatusCode | finalize () override
| Service overload: Finalize the service. More...
void | handle (const Incident &incident) override
| IIncidentListener override: Inform that a new incident has occurred. More...
StatusCode | stop () override
Public Member Functions inherited from extends< Service, IIncidentListener >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
| ~extends () override=default
| Virtual destructor. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName, bool createIf=true)
| Declare used tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
| ~PropertyHolder () override=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none") const
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleBase &ref, const std::string &doc="none")
| Specializations for various GaudiHandles. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, GaudiHandleArrayBase &ref, const std::string &doc="none")
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, DataObjectHandleBase &ref, const std::string &doc="none")
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
MSG::Level | outputLevel () const __attribute__((deprecated))
| Backward compatibility function for getting the output level. More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
Public Member Functions inherited from extend_interfaces< Interfaces... >
| ~extend_interfaces () override=default
| Virtual destructor. More...

## Protected Types
enum | EventType { EVENT = 1, FSR = 2 }

## Protected Member Functions
virtual void | record (EventType eventType)
MsgStream & | log () const
| Helper: Use message streamer. More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | setUpMessaging ()
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...

## Protected Attributes
Gaudi::Property< std::string > | m_ioPerfStats
Gaudi::Property< std::string > | m_setStreams {this, "Streams", "", ""}
Gaudi::Property< std::string > | m_basketSize {this, "BasketSize", "", ""}
Gaudi::Property< std::string > | m_bufferSize {this, "BufferSize", "", ""}
Gaudi::Property< std::string > | m_splitLevel {this, "SplitLevel", "", ""}
SmartIF< IIncidentSvc > | m_incidentSvc
| Reference to incident service. More...
std::unique_ptr< MsgStream > | m_log
| Message streamer. More...
TTree * | m_perfTree
std::unique_ptr< TFile > | m_perfFile
std::set< std::string > | m_outputs
Int_t | m_eventType
ULong_t | m_utime
ULong_t | m_stime
ULong_t | m_vsize
Long_t | m_eventNumber
Long_t | m_rss
Long_t | m_time
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, "[[deprecated]] unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Additional Inherited Members
Public Types inherited from extends< Service, IIncidentListener >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
typedef Gaudi::PluginService::Factory< IService *, const std::string &, ISvcLocator * > | Factory
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...

## Detailed Description

Description:

RootPerfMonSvc class implementation definition.

Author
  Markus Frank, Ivan Valencik

Version
  1.0

Date
  20/12/2009

Definition at line 40 of file RootPerfMonSvc.h.

## Member Enumeration Documentation

enum Gaudi::RootPerfMonSvc::EventType
| protected

Enumerator
EVENT |
FSR |

Definition at line 67 of file RootPerfMonSvc.h.

67 { EVENT = 1, FSR = 2 };
Gaudi::RootPerfMonSvc::EVENT
Definition: RootPerfMonSvc.h:67
Gaudi::RootPerfMonSvc::FSR
Definition: RootPerfMonSvc.h:67

## Constructor & Destructor Documentation

Gaudi::RootPerfMonSvc::~RootPerfMonSvc | ( |  | ) |
| override default

Standard destructor.

## Member Function Documentation

StatusCode RootPerfMonSvc::error | ( | const std::string & | msg | ) |

Standard way to print errors.

after the printout an exception is thrown.

Parameters

  msg | [IN] Message string to be printed.

Returns
  Status code returning failure.

Definition at line 33 of file RootPerfMonSvc.cpp.

34 {
35 if ( m_log ) {
36 log() << MSG::ERROR << "Error: " << msg << endmsg;
37 return S_FAIL;
38 }
39 MsgStream m( msgSvc(), name() );
40 m << MSG::ERROR << "Error: " << msg << endmsg;
41 return S_FAIL;
42 }
MsgStream
Definition of the MsgStream class used to transmit messages.
Definition: MsgStream.h:24
Service::name
const std::string & name() const override
Retrieve name of the service.
Definition: Service.cpp:289
S_FAIL
#define S_FAIL
Definition: RootPerfMonSvc.cpp:30
Gaudi::Units::m
constexpr double m
Definition: SystemOfUnits.h:94
CommonMessagingBase::msgSvc
const SmartIF< IMessageSvc > & msgSvc() const
The standard message service.
Definition: CommonMessaging.h:75
Gaudi::RootPerfMonSvc::log
MsgStream & log() const
Helper: Use message streamer.
Definition: RootPerfMonSvc.h:73
MSG::ERROR
Definition: IMessageSvc.h:16
Gaudi::RootPerfMonSvc::m_log
std::unique_ptr< MsgStream > m_log
Message streamer.
Definition: RootPerfMonSvc.h:54
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:209

StatusCode RootPerfMonSvc::finalize | ( |  | ) |
| override

Service overload: Finalize the service.

Definition at line 134 of file RootPerfMonSvc.cpp.

135 {
136 record( FSR );
137 log() << MSG::INFO;
138 m_log.reset();
139 m_incidentSvc.reset();
140
141 m_perfFile->Write();
142 m_perfFile->Close();
143 m_perfFile.reset();
144
145 return Service::finalize();
146 }
Service::finalize
StatusCode finalize() override
Definition: Service.cpp:174
Gaudi::RootPerfMonSvc::m_perfFile
std::unique_ptr< TFile > m_perfFile
Definition: RootPerfMonSvc.h:58
Gaudi::RootPerfMonSvc::record
virtual void record(EventType eventType)
Definition: RootPerfMonSvc.cpp:89
Gaudi::RootPerfMonSvc::m_incidentSvc
SmartIF< IIncidentSvc > m_incidentSvc
Reference to incident service.
Definition: RootPerfMonSvc.h:52
std::unique_ptr::reset
T reset(T...args)
Gaudi::RootPerfMonSvc::log
MsgStream & log() const
Helper: Use message streamer.
Definition: RootPerfMonSvc.h:73
Gaudi::RootPerfMonSvc::FSR
Definition: RootPerfMonSvc.h:67
SmartIF::reset
void reset(TYPE *ptr=nullptr)
Set the internal pointer to the passed one disposing of the old one.
Definition: SmartIF.h:92
MSG::INFO
Definition: IMessageSvc.h:16
Gaudi::RootPerfMonSvc::m_log
std::unique_ptr< MsgStream > m_log
Message streamer.
Definition: RootPerfMonSvc.h:54

void RootPerfMonSvc::handle | ( | const Incident & | incident | ) |
| override

IIncidentListener override: Inform that a new incident has occurred.

Definition at line 101 of file RootPerfMonSvc.cpp.

102 {
103 std::string t = incident.type();
104 if ( !t.compare( IncidentType::BeginEvent ) ) {
105 m_eventNumber++;
106 record( EVENT );
107 return;
108 }
109 if ( !t.compare( "CONNECTED_OUTPUT" ) ) {
110 m_outputs.insert( incident.source() );
111 }
112 }
Incident::type
const std::string & type() const
Access to the incident type.
Definition: Incident.h:41
Gaudi::RootPerfMonSvc::m_eventNumber
Long_t m_eventNumber
Definition: RootPerfMonSvc.h:64
Incident::source
const std::string & source() const
Access to the source of the incident.
Definition: Incident.h:47
Gaudi::RootPerfMonSvc::record
virtual void record(EventType eventType)
Definition: RootPerfMonSvc.cpp:89
std::string
STL class.
std::set::insert
T insert(T...args)
Gaudi::RootPerfMonSvc::EVENT
Definition: RootPerfMonSvc.h:67
Gaudi::RootPerfMonSvc::m_outputs
std::set< std::string > m_outputs
Definition: RootPerfMonSvc.h:60
std::string::compare
T compare(T...args)

StatusCode RootPerfMonSvc::initialize | ( |  | ) |
| override

Service overload: initialize the service.

Definition at line 45 of file RootPerfMonSvc.cpp.

46 {
47 string cname;
48 StatusCode status = Service::initialize();
49 if ( !status.isSuccess() ) return error( "Failed to initialize Service base class." );
50 m_log.reset( new MsgStream( msgSvc(), name() ) );
51 m_incidentSvc = service( "IncidentSvc" );
52 if ( !m_incidentSvc ) return error( "Unable to localize interface from service:IncidentSvc" );
53
54 m_incidentSvc->addListener( this, IncidentType::BeginEvent, 1, false, false );
55 m_incidentSvc->addListener( this, "NEW_STREAM", 1, false, false );
56 m_incidentSvc->addListener( this, "CONNECTED_OUTPUT", 1, false, false );
57
58 if ( m_ioPerfStats.empty() ) return error( "Performance monitoring file IOPerfStats was not defined." );
59
60 TDirectory::TContext ctxt( nullptr );
61 m_perfFile.reset( new TFile( m_ioPerfStats.value().c_str(), "RECREATE" ) );
62 if ( !m_perfFile ) return error( "Could not create ROOT file." );
63
64 if ( !( m_perfTree = new TTree( "T", "performance measurement" ) ) ) return error( "Could not create tree." );
65
66 m_perfTree->Branch( "utime", &m_utime, "utime/l" );
67 m_perfTree->Branch( "stime", &m_stime, "stime/l" );
68 m_perfTree->Branch( "vsize", &m_vsize, "vsize/l" );
69 m_perfTree->Branch( "rss", &m_rss, "rss/L" );
70 m_perfTree->Branch( "time", &m_time, "time/L" );
71 m_eventNumber = 0;
72 m_perfTree->Branch( "event_number", &m_eventNumber, "event_number/L" );
73 m_perfTree->Branch( "event_type", &m_eventType, "event_type/I" );
74
75 if ( m_setStreams.empty() ) m_setStreams = "undefined";
76 if ( m_basketSize.empty() ) m_basketSize = "undefined";
77 if ( m_bufferSize.empty() ) m_bufferSize = "undefined";
78 if ( m_splitLevel.empty() ) m_splitLevel = "undefined";
79
80 auto map = new TMap();
81 map->Add( new TObjString( "streams" ), new TObjString( m_setStreams.value().c_str() ) );
82 map->Add( new TObjString( "basket_size" ), new TObjString( m_basketSize.value().c_str() ) );
83 map->Add( new TObjString( "buffer_size" ), new TObjString( m_bufferSize.value().c_str() ) );
84 map->Add( new TObjString( "split_level" ), new TObjString( m_splitLevel.value().c_str() ) );
85 map->Write( "params", TObject::kSingleKey );
86 return S_OK;
87 }
Gaudi::RootPerfMonSvc::m_basketSize
Gaudi::Property< std::string > m_basketSize
Definition: RootPerfMonSvc.h:47
MsgStream
Definition of the MsgStream class used to transmit messages.
Definition: MsgStream.h:24
Service::initialize
StatusCode initialize() override
Definition: Service.cpp:64
Service::name
const std::string & name() const override
Retrieve name of the service.
Definition: Service.cpp:289
Gaudi::RootPerfMonSvc::m_eventType
Int_t m_eventType
Definition: RootPerfMonSvc.h:62
Gaudi::RootPerfMonSvc::m_time
Long_t m_time
Definition: RootPerfMonSvc.h:64
Gaudi::RootPerfMonSvc::m_eventNumber
Long_t m_eventNumber
Definition: RootPerfMonSvc.h:64
Gaudi::RootPerfMonSvc::m_stime
ULong_t m_stime
Definition: RootPerfMonSvc.h:63
Gaudi::RootPerfMonSvc::m_perfFile
std::unique_ptr< TFile > m_perfFile
Definition: RootPerfMonSvc.h:58
StatusCode::isSuccess
bool isSuccess() const
Test for a status code of SUCCESS.
Definition: StatusCode.h:75
S_OK
#define S_OK
Definition: RootPerfMonSvc.cpp:29
Gaudi::RootPerfMonSvc::m_vsize
ULong_t m_vsize
Definition: RootPerfMonSvc.h:63
std::map
STL class.
Gaudi::RootPerfMonSvc::m_incidentSvc
SmartIF< IIncidentSvc > m_incidentSvc
Reference to incident service.
Definition: RootPerfMonSvc.h:52
Gaudi::RootPerfMonSvc::m_utime
ULong_t m_utime
Definition: RootPerfMonSvc.h:63
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:106
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:28
std::unique_ptr::reset
T reset(T...args)
CommonMessagingBase::msgSvc
const SmartIF< IMessageSvc > & msgSvc() const
The standard message service.
Definition: CommonMessaging.h:75
Gaudi::RootPerfMonSvc::m_splitLevel
Gaudi::Property< std::string > m_splitLevel
Definition: RootPerfMonSvc.h:49
Gaudi::RootPerfMonSvc::m_perfTree
TTree * m_perfTree
Definition: RootPerfMonSvc.h:56
Gaudi::RootPerfMonSvc::m_rss
Long_t m_rss
Definition: RootPerfMonSvc.h:64
IIncidentSvc::addListener
virtual void addListener(IIncidentListener *lis, const std::string &type="", long priority=0, bool rethrow=false, bool singleShot=false)=0
Add listener.
Gaudi::RootPerfMonSvc::m_ioPerfStats
Gaudi::Property< std::string > m_ioPerfStats
Definition: RootPerfMonSvc.h:43
Gaudi::RootPerfMonSvc::m_bufferSize
Gaudi::Property< std::string > m_bufferSize
Definition: RootPerfMonSvc.h:48
Service::service
StatusCode service(const std::string &name, const T *&psvc, bool createIf=true) const
Access a service by name, creating it if it doesn&#39;t already exist.
Definition: Service.h:85
Gaudi::RootPerfMonSvc::m_setStreams
Gaudi::Property< std::string > m_setStreams
Definition: RootPerfMonSvc.h:46
Gaudi::RootPerfMonSvc::m_log
std::unique_ptr< MsgStream > m_log
Message streamer.
Definition: RootPerfMonSvc.h:54

MsgStream& Gaudi::RootPerfMonSvc::log | ( |  | ) | const
| inline protected

Helper: Use message streamer.

Definition at line 73 of file RootPerfMonSvc.h.

73 { return *m_log; }
Gaudi::RootPerfMonSvc::m_log
std::unique_ptr< MsgStream > m_log
Message streamer.
Definition: RootPerfMonSvc.h:54

void RootPerfMonSvc::record | ( | EventType | eventType | ) |
| protected virtual

Definition at line 89 of file RootPerfMonSvc.cpp.

90 {
91 SysProcStat data;
92 m_eventType = eventType;
93 m_utime = (ULong_t)data.utime;
94 m_stime = (ULong_t)data.stime;
95 m_vsize = (ULong_t)data.vsize;
96 m_rss = (Long_t)data.rss;
97 m_time = (Long_t)data.time;
98 m_perfTree->Fill();
99 }
Gaudi::SysProcStat::stime
long unsigned stime
Definition: SysProcStat.h:18
Gaudi::RootPerfMonSvc::m_eventType
Int_t m_eventType
Definition: RootPerfMonSvc.h:62
Gaudi::RootPerfMonSvc::m_time
Long_t m_time
Definition: RootPerfMonSvc.h:64
Gaudi::RootPerfMonSvc::m_stime
ULong_t m_stime
Definition: RootPerfMonSvc.h:63
Gaudi::RootPerfMonSvc::m_vsize
ULong_t m_vsize
Definition: RootPerfMonSvc.h:63
Gaudi::RootPerfMonSvc::m_utime
ULong_t m_utime
Definition: RootPerfMonSvc.h:63
Gaudi::SysProcStat::vsize
long unsigned vsize
Definition: SysProcStat.h:18
Gaudi::SysProcStat::time
long time
Definition: SysProcStat.h:23
Gaudi::RootPerfMonSvc::m_perfTree
TTree * m_perfTree
Definition: RootPerfMonSvc.h:56
Gaudi::SysProcStat::utime
long unsigned utime
Definition: SysProcStat.h:18
Gaudi::RootPerfMonSvc::m_rss
Long_t m_rss
Definition: RootPerfMonSvc.h:64
Gaudi::SysProcStat::rss
long int rss
Definition: SysProcStat.h:20
Gaudi::SysProcStat
Definition: SysProcStat.h:13

StatusCode RootPerfMonSvc::stop | ( |  | ) |
| override

Definition at line 115 of file RootPerfMonSvc.cpp.

116 {
117 char text[64];
118 record( FSR );
119 auto map = new TMap();
120 for ( const auto& i : m_outputs ) {
121 const char* fn = i.c_str();
122 Long_t id, siz, flags, tim;
123 if ( 0 == gSystem->GetPathInfo( fn, &id, &siz, &flags, &tim ) ) {
124 ::sprintf( text, "%ld", siz );
125 map->Add( new TObjString( fn ), new TObjString( text ) );
126 }
127 }
128 TDirectory::TContext ctxt( m_perfFile.get() );
129 map->Write( "Outputs", TObject::kSingleKey );
130 return S_OK;
131 }
Gaudi::RootPerfMonSvc::m_perfFile
std::unique_ptr< TFile > m_perfFile
Definition: RootPerfMonSvc.h:58
Gaudi::RootPerfMonSvc::record
virtual void record(EventType eventType)
Definition: RootPerfMonSvc.cpp:89
S_OK
#define S_OK
Definition: RootPerfMonSvc.cpp:29
std::map
STL class.
std::unique_ptr::get
T get(T...args)
Gaudi::RootPerfMonSvc::FSR
Definition: RootPerfMonSvc.h:67
Gaudi::RootPerfMonSvc::m_outputs
std::set< std::string > m_outputs
Definition: RootPerfMonSvc.h:60

## Member Data Documentation

Gaudi::Property<std::string> Gaudi::RootPerfMonSvc::m_basketSize {this, "BasketSize", "", ""}
| protected

Definition at line 47 of file RootPerfMonSvc.h.

Gaudi::Property<std::string> Gaudi::RootPerfMonSvc::m_bufferSize {this, "BufferSize", "", ""}
| protected

Definition at line 48 of file RootPerfMonSvc.h.

Long_t Gaudi::RootPerfMonSvc::m_eventNumber
| protected

Definition at line 64 of file RootPerfMonSvc.h.

Int_t Gaudi::RootPerfMonSvc::m_eventType
| protected

Definition at line 62 of file RootPerfMonSvc.h.

SmartIF<IIncidentSvc> Gaudi::RootPerfMonSvc::m_incidentSvc
| protected

Reference to incident service.

Definition at line 52 of file RootPerfMonSvc.h.

Gaudi::Property<std::string> Gaudi::RootPerfMonSvc::m_ioPerfStats
| protected

Initial value:
{this, "IOPerfStats", "",
"Enable TTree IOperfStats if not empty; otherwise perf stat file name"}

Definition at line 43 of file RootPerfMonSvc.h.

std::unique_ptr<MsgStream> Gaudi::RootPerfMonSvc::m_log
| protected

Message streamer.

Definition at line 54 of file RootPerfMonSvc.h.

std::set<std::string> Gaudi::RootPerfMonSvc::m_outputs
| protected

Definition at line 60 of file RootPerfMonSvc.h.

std::unique_ptr<TFile> Gaudi::RootPerfMonSvc::m_perfFile
| protected

Definition at line 58 of file RootPerfMonSvc.h.

TTree* Gaudi::RootPerfMonSvc::m_perfTree
| protected

Definition at line 56 of file RootPerfMonSvc.h.

Long_t Gaudi::RootPerfMonSvc::m_rss
| protected

Definition at line 64 of file RootPerfMonSvc.h.

Gaudi::Property<std::string> Gaudi::RootPerfMonSvc::m_setStreams {this, "Streams", "", ""}
| protected

Definition at line 46 of file RootPerfMonSvc.h.

Gaudi::Property<std::string> Gaudi::RootPerfMonSvc::m_splitLevel {this, "SplitLevel", "", ""}
| protected

Definition at line 49 of file RootPerfMonSvc.h.

ULong_t Gaudi::RootPerfMonSvc::m_stime
| protected

Definition at line 63 of file RootPerfMonSvc.h.

Long_t Gaudi::RootPerfMonSvc::m_time
| protected

Definition at line 64 of file RootPerfMonSvc.h.

ULong_t Gaudi::RootPerfMonSvc::m_utime
| protected

Definition at line 63 of file RootPerfMonSvc.h.

ULong_t Gaudi::RootPerfMonSvc::m_vsize
| protected

Definition at line 63 of file RootPerfMonSvc.h.

The documentation for this class was generated from the following files:

- RootCnv/RootCnv/RootPerfMonSvc.h
- RootCnv/src/RootPerfMonSvc.cpp